
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Sync_jobsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sync_jobs = await db.sync_jobs.create(
            {
                id: data.id || undefined,
        
        job_type: data.job_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        finished_at: data.finished_at
        ||
        null
            ,
            
        processed_count: data.processed_count
        ||
        null
            ,
            
        inserted_count: data.inserted_count
        ||
        null
            ,
            
        updated_count: data.updated_count
        ||
        null
            ,
            
        skipped_count: data.skipped_count
        ||
        null
            ,
            
        error_count: data.error_count
        ||
        null
            ,
            
        error_summary: data.error_summary
        ||
        null
            ,
            
        job_payload_json: data.job_payload_json
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await sync_jobs.setTriggered_by( data.triggered_by || null, {
            transaction,
        });
        

        

        

        return sync_jobs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const sync_jobsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                job_type: item.job_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                finished_at: item.finished_at
            ||
            null
            ,
            
                processed_count: item.processed_count
            ||
            null
            ,
            
                inserted_count: item.inserted_count
            ||
            null
            ,
            
                updated_count: item.updated_count
            ||
            null
            ,
            
                skipped_count: item.skipped_count
            ||
            null
            ,
            
                error_count: item.error_count
            ||
            null
            ,
            
                error_summary: item.error_summary
            ||
            null
            ,
            
                job_payload_json: item.job_payload_json
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const sync_jobs = await db.sync_jobs.bulkCreate(sync_jobsData, { transaction });

        // For each item created, replace relation files
        

        return sync_jobs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const sync_jobs = await db.sync_jobs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.job_type !== undefined) updatePayload.job_type = data.job_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.finished_at !== undefined) updatePayload.finished_at = data.finished_at;
        
        
        if (data.processed_count !== undefined) updatePayload.processed_count = data.processed_count;
        
        
        if (data.inserted_count !== undefined) updatePayload.inserted_count = data.inserted_count;
        
        
        if (data.updated_count !== undefined) updatePayload.updated_count = data.updated_count;
        
        
        if (data.skipped_count !== undefined) updatePayload.skipped_count = data.skipped_count;
        
        
        if (data.error_count !== undefined) updatePayload.error_count = data.error_count;
        
        
        if (data.error_summary !== undefined) updatePayload.error_summary = data.error_summary;
        
        
        if (data.job_payload_json !== undefined) updatePayload.job_payload_json = data.job_payload_json;
        
        
        updatePayload.updatedById = currentUser.id;

        await sync_jobs.update(updatePayload, {transaction});

        
        
        if (data.triggered_by !== undefined) {
            await sync_jobs.setTriggered_by(
              
              data.triggered_by,
              
              { transaction }
            );
        }
        

        
        

        

        return sync_jobs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sync_jobs = await db.sync_jobs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of sync_jobs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of sync_jobs) {
                await record.destroy({transaction});
            }
        });


        return sync_jobs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const sync_jobs = await db.sync_jobs.findByPk(id, options);

        await sync_jobs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await sync_jobs.destroy({
            transaction
        });

        return sync_jobs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const sync_jobs = await db.sync_jobs.findOne(
            { where },
            { transaction },
        );

        if (!sync_jobs) {
            return sync_jobs;
        }

        const output = sync_jobs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.triggered_by = await sync_jobs.getTriggered_by({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'triggered_by',
        
        where: filter.triggered_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.triggered_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.triggered_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.error_summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'sync_jobs',
                        'error_summary',
                        filter.error_summary,
                    ),
                };
            }
            
            if (filter.job_payload_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'sync_jobs',
                        'job_payload_json',
                        filter.job_payload_json,
                    ),
                };
            }
            

            
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.finished_atRange) {
                const [start, end] = filter.finished_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    finished_at: {
                    ...where.finished_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    finished_at: {
                    ...where.finished_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.processed_countRange) {
                const [start, end] = filter.processed_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    processed_count: {
                    ...where.processed_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    processed_count: {
                    ...where.processed_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.inserted_countRange) {
                const [start, end] = filter.inserted_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    inserted_count: {
                    ...where.inserted_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    inserted_count: {
                    ...where.inserted_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.updated_countRange) {
                const [start, end] = filter.updated_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    updated_count: {
                    ...where.updated_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    updated_count: {
                    ...where.updated_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.skipped_countRange) {
                const [start, end] = filter.skipped_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    skipped_count: {
                    ...where.skipped_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    skipped_count: {
                    ...where.skipped_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.error_countRange) {
                const [start, end] = filter.error_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    error_count: {
                    ...where.error_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    error_count: {
                    ...where.error_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.job_type) {
                where = {
                    ...where,
                job_type: filter.job_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.sync_jobs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'sync_jobs',
                        'job_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.sync_jobs.findAll({
            attributes: [ 'id', 'job_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['job_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.job_type,
        }));
    }

    
};

